#include <bits/stdc++.h>
#include <queue>
using namespace std;
#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

int dist(const pii &a) {
	if(a.first % 3 != 2 || a.second % 3 != 2) {
		return a.first + a.second;
	}
	return a.first + a.second + 2;
}

struct Compare {
	bool compare(const pii &a, const pii &b) {
		int d = dist(a) - dist(b);
		int dx = a.first - b.first;
		int dy = a.second - b.second;
		if(d != 0) return d > 0;
		if(dx != 0) return dx > 0;
		return dy > 0;
	}
	bool operator()(const pii &a, const pii &b) {
		return compare(a, b);
	}
};

/**
 * Lessons
 *  - Priority queue ordering
 *  - Manhattan distance, tiebreaking rules
 *  - Try to find edge cases
 */
int main() {
	cin.tie(0)->sync_with_stdio(0);
	cin.exceptions(cin.failbit);

	int T;
	cin >> T;
	rep(test_case, 0, T) {
		int n;
		cin >> n;
		int t[n];
		rep(i, 0, n) cin >> t[i];

		vector<pii> open_tables(n);
		int x = 0, y = 0;
		rep(person, 0, n) {
			open_tables[person] = {3 * x + 1, 3 * y + 1};
			x++, y--;
			if(y < 0) {
				y = x + y + 1;
				x = 0;
			}
		}

		priority_queue<pii, vector<pii>, Compare> pq;
		Compare compare;
		int open = 0;
		for(int person : t) {
			if(!(person == 1) || pq.empty() || compare.compare(pq.top(), open_tables[open])) {
				pii table = open_tables[open++];
				cout << table.first << ' ' << table.second << '\n';
				pq.push({ table.first, table.second + 1 });
				pq.push({ table.first + 1, table.second });
				pq.push({ table.first + 1, table.second + 1 });
			} else {
				pii table = pq.top();
				pq.pop();
				cout << table.first << ' ' << table.second << '\n';
			}
		}

	}
}
